## log4cxx 0.11.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
include(src/cmake/projectVersionDetails.cmake)
project(log4cxx VERSION ${log4cxx_VER} LANGUAGES CXX)
include(CTest)

# define the SO Version of the library. Version of the log4cxx project is subtly different than the version of the library
# (at least in the past it was project vesion: 0.a.b.c and the library so vesion a.b.c.0
set(LIBLOG4CXX_LIB_VERSION ${log4cxx_VERSION_MINOR}.${log4cxx_VERSION_PATCH}.${log4cxx_VERSION_TWEAK})
set(LIBLOG4CXX_LIB_SOVERSION ${log4cxx_VERSION_MINOR})

# FindAPR and FindAPR-util are not provided by APR and APR-Util so source them locally
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/src/cmake")

# Add support for linking statically
option(BUILD_SHARED_LIBS "Build shared libraries" ON)
if(NOT BUILD_SHARED_LIBS)
  set(LOG4CXX_COMPILE_DEFINITIONS LOG4CXX_STATIC)
endif()

# Find Apache Runtime
find_package(APR REQUIRED)

# Find Apache Runtime Utilities
find_package(APR-Util REQUIRED)

# Building
add_subdirectory(src)

## Installing
include(GNUInstallDirs)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src/main/include/log4cxx
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  FILES_MATCHING PATTERN "*.h"
)
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src/main/include/log4cxx
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  FILES_MATCHING PATTERN "*.h"
)

install(TARGETS log4cxx EXPORT log4cxxTargets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} 
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

IF(WIN32 AND BUILD_SHARED_LIBS AND LOG4CXX_INSTALL_PDB)
  INSTALL(FILES $<TARGET_PDB_FILE:log4cxx>
          DESTINATION ${CMAKE_INSTALL_BINDIR}
          CONFIGURATIONS RelWithDebInfo Debug
  )
ENDIF()

if(UNIX)
  # Support for pkg-config in consuming projects
  set(prefix "${CMAKE_INSTALL_PREFIX}")
  set(exec_prefix "${CMAKE_INSTALL_PREFIX}")
  set(libdir "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
  set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
  set(VERSION "${log4cxx_VERSION_MAJOR}.${log4cxx_VERSION_MINOR}.${log4cxx_VERSION_PATCH}")
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/liblog4cxx.pc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/liblog4cxx.pc"
  )

  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/liblog4cxx.pc" 
    DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pkgconfig)
endif(UNIX)

# Support for find_package(log4cxx) in consuming CMake projects using
# target_include_directories(myApplication PRIVATE $<TARGET_PROPERTY:log4cxx,INTERFACE_INCLUDE_DIRECTORIES>)
# target_link_libraries( myApplication PRIVATE log4cxx)
install(EXPORT log4cxxTargets
  FILE        log4cxxConfig.cmake
  DESTINATION share/cmake/log4cxx
)
# Support for find_package(log4cxx 0.11) in consuming CMake projects
include(CMakePackageConfigHelpers)
write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/log4cxxConfigVersion.cmake"
  VERSION       ${PROJECT_VERSION}
  COMPATIBILITY SameMinorVersion
)
install(FILES   "${CMAKE_CURRENT_BINARY_DIR}/log4cxxConfigVersion.cmake"
  DESTINATION   share/cmake/log4cxx
)

#
# Get the varaibles from the subdirectories
#
get_directory_property( HAS_LIBESMTP DIRECTORY src/main/include DEFINITION HAS_LIBESMTP )
get_directory_property( HAS_ODBC DIRECTORY src/main/include DEFINITION HAS_ODBC )
get_directory_property( HAS_SYSLOG DIRECTORY src/main/include DEFINITION HAS_SYSLOG )

foreach(varName HAS_STD_LOCALE  HAS_ODBC  HAS_MBSRTOWCS  HAS_WCSTOMBS  HAS_FWIDE  HAS_LIBESMTP  HAS_SYSLOG)
  if(${varName} EQUAL 0)
    set(${varName} "OFF" )
  elseif(${varName} EQUAL 1)
    set(${varName} "ON" )
  else()
    set(${varName} "UNKNOWN" )
  endif()
endforeach()

#
# Output configuration information
# Similar to APR CMake configuration
#
message(STATUS "")
message(STATUS "")
message(STATUS "log4cxx configuration summary:")
message(STATUS "")

message(STATUS "  Build shared library ............ : ${BUILD_SHARED_LIBS}")
message(STATUS "  Build tests ..................... : ${BUILD_TESTING}")
message(STATUS "  Install prefix .................. : ${CMAKE_INSTALL_PREFIX}")
message(STATUS "  C++ compiler .................... : ${CMAKE_CXX_COMPILER}")
message(STATUS "  log4cxx char API ................ : ${LOG4CXX_CHAR}")
message(STATUS "  log4cxx wchar API ............... : ${LOG4CXX_WCHAR_T}")
message(STATUS "  log4cxx unichar API ............. : ${LOG4CXX_UNICHAR}")
if(APPLE)
message(STATUS "  log4cxx cfstring API ............ : ${LOG4CXX_CFSTRING}")
endif()
message(STATUS "  logchar type .................... : ${LOG4CXX_CHAR}")
message(STATUS "  Using libESMTP .................. : ${HAS_LIBESMTP}")
message(STATUS "  ODBC library .................... : ${HAS_ODBC}")
message(STATUS "  syslog .......................... : ${HAS_SYSLOG}")

=== src/CMakeLists.txt ===
add_subdirectory(main)
target_compile_definitions(log4cxx PRIVATE ${LOG4CXX_COMPILE_DEFINITIONS} ${APR_COMPILE_DEFINITIONS} ${APR_UTIL_COMPILE_DEFINITIONS} )
target_include_directories(log4cxx INTERFACE $<INSTALL_INTERFACE:include> PRIVATE ${APR_INCLUDE_DIR} ${APR_UTIL_INCLUDE_DIR})
target_link_libraries(log4cxx PRIVATE ${APR_UTIL_LIBRARIES} ${XMLLIB_LIBRARIES} ${APR_LIBRARIES} ${APR_SYSTEM_LIBS})
if(WIN32)
# The ODBC appender is always enabled in the Windows configuration
target_link_libraries(log4cxx PRIVATE odbc32.lib)
option(LOG4CXX_INSTALL_PDB "Install .pdb files (if generated)"  ON)
endif()

if(BUILD_TESTING)
   add_subdirectory(test)
   add_subdirectory(examples/cpp)
endif()

=== src/test/CMakeLists.txt ===
find_package(Java COMPONENTS Development)
if(Java_Development_FOUND)
  add_subdirectory(java)
endif(Java_Development_FOUND)
add_subdirectory(cpp)

=== src/examples/cpp/CMakeLists.txt ===
set(ALL_LOG4CXX_EXAMPLES console delayedloop stream trivial)

foreach(exampleName IN LISTS ALL_LOG4CXX_EXAMPLES)
    add_executable(${exampleName} ${exampleName}.cpp)
    target_compile_definitions(${exampleName} PRIVATE ${LOG4CXX_COMPILE_DEFINITIONS} ${APR_COMPILE_DEFINITIONS} ${APR_UTIL_COMPILE_DEFINITIONS} )
    target_include_directories(${exampleName} PRIVATE ${CMAKE_CURRENT_LIST_DIR} $<TARGET_PROPERTY:log4cxx,INCLUDE_DIRECTORIES>)
    target_link_libraries(${exampleName} PRIVATE log4cxx ${APR_UTIL_LIBRARIES} ${XMLLIB_LIBRARIES} ${APR_LIBRARIES} ${APR_SYSTEM_LIBS})
endforeach()

=== src/main/cpp/CMakeLists.txt ===

# Options
option(LOG4CXX_BLOCKING_ASYNC_APPENDER "Async appender behaviour" ON)

# Build the log4cxx library
add_library(log4cxx action.cpp)
if(BUILD_SHARED_LIBS)
    target_compile_definitions(log4cxx PRIVATE LOG4CXX)
else()
    target_compile_definitions(log4cxx PUBLIC LOG4CXX_STATIC)
endif()
add_dependencies(log4cxx configure_log4cxx)
target_sources(log4cxx
  PRIVATE
  andfilter.cpp
  appenderattachableimpl.cpp
  appenderskeleton.cpp
  aprinitializer.cpp
  $<IF:$<BOOL:LOG4CXX_BLOCKING_ASYNC_APPENDER>,asyncappender.cpp,asyncappender_nonblocking.cpp>
  basicconfigurator.cpp
  bufferedwriter.cpp
  bytearrayinputstream.cpp
  bytearrayoutputstream.cpp
  bytebuffer.cpp
  cacheddateformat.cpp
  charsetdecoder.cpp
  charsetencoder.cpp
  class.cpp
  classnamepatternconverter.cpp
  classregistration.cpp
  condition.cpp
  configurator.cpp
  consoleappender.cpp
  cyclicbuffer.cpp
  dailyrollingfileappender.cpp
  datagrampacket.cpp
  datagramsocket.cpp
  date.cpp
  dateformat.cpp
  datelayout.cpp
  datepatternconverter.cpp
  defaultconfigurator.cpp
  defaultloggerfactory.cpp
  defaultrepositoryselector.cpp
  domconfigurator.cpp
  exception.cpp
  fallbackerrorhandler.cpp
  file.cpp
  fileappender.cpp
  filedatepatternconverter.cpp
  fileinputstream.cpp
  filelocationpatternconverter.cpp
  fileoutputstream.cpp
  filerenameaction.cpp
  filewatchdog.cpp
  filter.cpp
  filterbasedtriggeringpolicy.cpp
  fixedwindowrollingpolicy.cpp
  formattinginfo.cpp
  fulllocationpatternconverter.cpp
  gzcompressaction.cpp
  hierarchy.cpp
  htmllayout.cpp
  inetaddress.cpp
  inputstream.cpp
  inputstreamreader.cpp
  integer.cpp
  integerpatternconverter.cpp
  jsonlayout.cpp
  layout.cpp
  level.cpp
  levelmatchfilter.cpp
  levelpatternconverter.cpp
  levelrangefilter.cpp
  linelocationpatternconverter.cpp
  lineseparatorpatternconverter.cpp
  literalpatternconverter.cpp
  loader.cpp
  locale.cpp
  locationinfo.cpp
  logger.cpp
  loggermatchfilter.cpp
  loggerpatternconverter.cpp
  loggingevent.cpp
  loggingeventpatternconverter.cpp
  loglog.cpp
  logmanager.cpp
  logstream.cpp
  manualtriggeringpolicy.cpp
  mapfilter.cpp
  mdc.cpp
  messagebuffer.cpp
  messagepatternconverter.cpp
  methodlocationpatternconverter.cpp
  mutex.cpp
  nameabbreviator.cpp
  namepatternconverter.cpp
  ndc.cpp
  ndcpatternconverter.cpp
  nteventlogappender.cpp
  objectimpl.cpp
  objectoutputstream.cpp
  objectptr.cpp
  obsoleterollingfileappender.cpp
  odbcappender.cpp
  onlyonceerrorhandler.cpp
  optionconverter.cpp
  outputdebugstringappender.cpp
  outputstream.cpp
  outputstreamwriter.cpp
  patternconverter.cpp
  patternlayout.cpp
  patternparser.cpp
  pool.cpp
  properties.cpp
  propertiespatternconverter.cpp
  propertyconfigurator.cpp
  propertyresourcebundle.cpp
  propertysetter.cpp
  reader.cpp
  relativetimedateformat.cpp
  relativetimepatternconverter.cpp
  resourcebundle.cpp
  rollingfileappender.cpp
  rollingpolicy.cpp
  rollingpolicybase.cpp
  rolloverdescription.cpp
  rootlogger.cpp
  serversocket.cpp
  simpledateformat.cpp
  simplelayout.cpp
  sizebasedtriggeringpolicy.cpp
  smtpappender.cpp
  socket.cpp
  socketappender.cpp
  socketappenderskeleton.cpp
  sockethubappender.cpp
  socketoutputstream.cpp
  strftimedateformat.cpp
  stringhelper.cpp
  stringmatchfilter.cpp
  stringtokenizer.cpp
  synchronized.cpp
  syslogappender.cpp
  syslogwriter.cpp
  system.cpp
  systemerrwriter.cpp
  systemoutwriter.cpp
  telnetappender.cpp
  threadcxx.cpp
  threadlocal.cpp
  threadpatternconverter.cpp
  threadspecificdata.cpp
  throwableinformationpatternconverter.cpp
  timebasedrollingpolicy.cpp
  timezone.cpp
  transcoder.cpp
  transform.cpp
  triggeringpolicy.cpp
  ttcclayout.cpp
  writer.cpp
  writerappender.cpp
  xmllayout.cpp
  xmlsocketappender.cpp
  zipcompressaction.cpp
)
set_target_properties(log4cxx PROPERTIES
  VERSION ${LIBLOG4CXX_LIB_VERSION}
  SOVERSION ${LIBLOG4CXX_LIB_SOVERSION}
)

=== src/main/include/CMakeLists.txt ===
# Configure
if(WIN32)
add_custom_target(configure_log4cxx
  COMMAND "${CMAKE_COMMAND}" -E copy_if_different
    ${CMAKE_CURRENT_SOURCE_DIR}/log4cxx/log4cxx.hw
    ${CMAKE_CURRENT_BINARY_DIR}/log4cxx/log4cxx.h
  COMMAND "${CMAKE_COMMAND}" -E copy_if_different
    ${CMAKE_CURRENT_SOURCE_DIR}/log4cxx/private/log4cxx_private.hw
    ${CMAKE_CURRENT_BINARY_DIR}/log4cxx/private/log4cxx_private.h
  DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/log4cxx/log4cxx.hw
    ${CMAKE_CURRENT_SOURCE_DIR}/log4cxx/private/log4cxx_private.hw
  BYPRODUCTS
    ${CMAKE_CURRENT_BINARY_DIR}/log4cxx/log4cxx.h
    ${CMAKE_CURRENT_BINARY_DIR}/log4cxx/private/log4cxx_private.h
)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/log4cxx/version_info.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/log4cxx/version_info.h
               @ONLY
)
else()
# Configure log4cxx.h
set(LOG4CXX_CHAR "utf-8" CACHE STRING "Interal character representation, choice of utf-8 (default), wchar_t, unichar")
set_property(CACHE LOG4CXX_CHAR PROPERTY STRINGS "utf-8" "wchar_t" "unichar")
set(LOGCHAR_IS_UNICHAR 0)
set(LOGCHAR_IS_WCHAR 0)
set(LOGCHAR_IS_UTF8 0)
if(${LOG4CXX_CHAR} STREQUAL "unichar")
  set(LOGCHAR_IS_UNICHAR 1)
elseif(${LOG4CXX_CHAR} STREQUAL "wchar_t")
  set(LOGCHAR_IS_WCHAR 1)
else()
  set(LOGCHAR_IS_UTF8 1)
endif()
option(LOG4CXX_WCHAR_T "Enable wchar_t API methods" ON)
option(LOG4CXX_UNICHAR "Enable UniChar API methods" OFF)
if(APPLE)
option(LOG4CXX_CFSTRING "Enable CFString API methods, requires Mac OS/X CoreFoundation" OFF)
endif()
set(CHAR_API 1)
foreach(varName WCHAR_T  UNICHAR  CFSTRING )
  if(${LOG4CXX_${varName}})
    set("${varName}_API" 1)
  else()
    set("${varName}_API" 0)
  endif()
endforeach()
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/log4cxx/log4cxx.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/log4cxx/log4cxx.h
               @ONLY
)

# Configure log4cxx_private.h
set(LOG4CXX_CHARSET "locale" CACHE STRING "LogString characters, choice of locale (default), utf-8, ISO-8859-1, US-ASCII, EBCDIC")
set_property(CACHE LOG4CXX_CHARSET PROPERTY STRINGS "locale" "utf-8" "ISO-8859-1" "US-ASCII" "EBCDIC")
set(CHARSET_EBCDIC 0)
set(CHARSET_USASCII 0)
set(CHARSET_ISO88591 0)
set(CHARSET_UTF8 0)
if(${LOG4CXX_CHARSET} STREQUAL "EBCDIC")
  set(CHARSET_EBCDIC 1)
elseif(${LOG4CXX_CHARSET} STREQUAL "US-ASCII")
  set(CHARSET_USASCII 1)
elseif(${LOG4CXX_CHARSET} STREQUAL "ISO-8859-1")
  set(CHARSET_ISO88591 1)
elseif(${LOG4CXX_CHARSET} STREQUAL "utf-8")
  set(CHARSET_UTF8 1)
endif()

#
# Test for various functions
#
include(CheckFunctionExists)
include(CheckCXXSymbolExists)
include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)

CHECK_INCLUDE_FILE_CXX(locale HAS_STD_LOCALE)
CHECK_INCLUDE_FILES(sqlext.h HAS_ODBC)
CHECK_FUNCTION_EXISTS(mbsrtowcs HAS_MBSRTOWCS)
CHECK_FUNCTION_EXISTS(wcstombs HAS_WCSTOMBS)
CHECK_FUNCTION_EXISTS(fwide HAS_FWIDE)
CHECK_LIBRARY_EXISTS(esmtp smtp_create_session "" HAS_LIBESMTP)
CHECK_FUNCTION_EXISTS(syslog HAS_SYSLOG)

foreach(varName HAS_STD_LOCALE  HAS_ODBC  HAS_MBSRTOWCS  HAS_WCSTOMBS  HAS_FWIDE  HAS_LIBESMTP  HAS_SYSLOG)
  if(${varName} EQUAL 0)
    continue()
  elseif(${varName} EQUAL 1)
    continue()
  elseif("${varName}" STREQUAL "ON")
    set(${varName} 1 )
  elseif("${varName}" STREQUAL "OFF")
    set(${varName} 0 )
  else()
    set(${varName} 0 )
  endif()
endforeach()


configure_file(${CMAKE_CURRENT_SOURCE_DIR}/log4cxx/private/log4cxx_private.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/log4cxx/private/log4cxx_private.h
               @ONLY
)

# Provide the dependencies
add_custom_target(configure_log4cxx
  COMMAND "${CMAKE_COMMAND}" -E echo "Checking configuration"
  DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/log4cxx/log4cxx.h.in
    ${CMAKE_CURRENT_SOURCE_DIR}/log4cxx/private/log4cxx_private.h.in
  BYPRODUCTS
    ${CMAKE_CURRENT_BINARY_DIR}/log4cxx/log4cxx.h
    ${CMAKE_CURRENT_BINARY_DIR}/log4cxx/private/log4cxx_private.h
)
endif()

=== src/main/resources/CMakeLists.txt ===
# Configure
if(WIN32)
target_sources(log4cxx
  PRIVATE
  log4cxx.rc
)
endif()

=== src/test/cpp/CMakeLists.txt ===
# Components required by all tests
add_library(testingFramework STATIC abts.cpp appenderskeletontestcase.cpp logunit.cpp vectorappender.cpp writerappendertestcase.cpp )
target_compile_definitions(testingFramework PRIVATE ${LOG4CXX_COMPILE_DEFINITIONS} ${APR_COMPILE_DEFINITIONS} ${APR_UTIL_COMPILE_DEFINITIONS} )
target_include_directories(testingFramework PRIVATE ${CMAKE_CURRENT_LIST_DIR} $<TARGET_PROPERTY:log4cxx,INCLUDE_DIRECTORIES>)
add_subdirectory(util)
target_sources(testingUtilities PRIVATE xml/xlevel.cpp)

# Tests defined in this directory
set(ALL_LOG4CXX_TESTS
    asyncappendertestcase
    consoleappendertestcase
    decodingtest
    encodingtest
    fileappendertest
    filetestcase
    hierarchytest
    hierarchythresholdtestcase
    jsonlayouttest
    l7dtestcase
    leveltestcase
    loggertestcase
    mdctestcase
    minimumtestcase
    ndctestcase
    patternlayouttest
    propertyconfiguratortest
    rollingfileappendertestcase
    streamtestcase
)
foreach(fileName IN LISTS ALL_LOG4CXX_TESTS)
    add_executable(${fileName} "${fileName}.cpp")
endforeach()
target_sources(rollingfileappendertestcase PRIVATE fileappendertestcase.cpp)

# Tests defined in subdirectories
add_subdirectory(helpers)
add_subdirectory(customlogger)
if(LOG4CXX_HAS_ODBC OR WIN32)
    add_subdirectory(db)
endif()
add_subdirectory(defaultinit)
add_subdirectory(filter)
add_subdirectory(net)
if(WIN32)
    add_subdirectory(nt)
endif()
add_subdirectory(pattern)
add_subdirectory(rolling)
add_subdirectory(spi)
add_subdirectory(varia)
add_subdirectory(xml)

foreach(testName IN LISTS ALL_LOG4CXX_TESTS)
    target_compile_definitions(${testName} PRIVATE ${LOG4CXX_COMPILE_DEFINITIONS} ${APR_COMPILE_DEFINITIONS} ${APR_UTIL_COMPILE_DEFINITIONS} )
    target_include_directories(${testName} PRIVATE ${CMAKE_CURRENT_LIST_DIR} $<TARGET_PROPERTY:log4cxx,INCLUDE_DIRECTORIES>)
    target_link_libraries(${testName} PRIVATE testingFramework testingUtilities log4cxx ${APR_LIBRARIES} ${APR_SYSTEM_LIBS})
    add_test(NAME ${testName}
        COMMAND ${testName} -v
        WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/../resources
    )

    if(WIN32)
        get_filename_component(APR_DLL_DIR "${APR_DLL}" DIRECTORY)
        get_filename_component(APR_UTIL_DLL_DIR "${APR_UTIL_DLL}" DIRECTORY)
        get_filename_component(XMLLIB_DLL_DIR "${XMLLIB_DLL}" DIRECTORY)
        set(PATH_FOR_TESTS $<SHELL_PATH:$<TARGET_FILE_DIR:log4cxx>> ${APR_DLL_DIR} ${APR_UTIL_DLL_DIR} ${XMLLIB_DLL_DIR})
        list(REMOVE_DUPLICATES PATH_FOR_TESTS)
        if(${testName} STREQUAL socketservertestcase)
            set_tests_properties(socketservertestcase PROPERTIES
                ENVIRONMENT "SOCKET_SERVER_PARAMETER_FILE=${START_SOCKET_SERVER_PARAMETER_FILE};PATH=${LOG4CXX_DLL_DIR}\;${APR_DLL_DIR}\;${APR_UTIL_DLL_DIR}"
            )
        else()
           set_tests_properties(${testName} PROPERTIES
                ENVIRONMENT "TOTO=wonderful;key1=value1;key2=value2;PATH==${LOG4CXX_DLL_DIR}\;${APR_DLL_DIR}\;${APR_UTIL_DLL_DIR}"
           )
        endif()
    else()
        if(${testName} STREQUAL socketservertestcase)
            set_tests_properties(socketservertestcase PROPERTIES
                ENVIRONMENT "SOCKET_SERVER_PARAMETER_FILE=${START_SOCKET_SERVER_PARAMETER_FILE}"
            )
        else()
           set_tests_properties(${testName} PROPERTIES
                ENVIRONMENT "TOTO=wonderful;key1=value1;key2=value2"
           )
        endif()
    endif()
endforeach()

=== src/test/cpp/customlogger/CMakeLists.txt ===
add_executable(xloggertestcase xloggertestcase.cpp xlogger.cpp)
set(ALL_LOG4CXX_TESTS ${ALL_LOG4CXX_TESTS} xloggertestcase PARENT_SCOPE)

=== src/test/cpp/db/CMakeLists.txt ===
add_executable(odbcappendertestcase odbcappendertestcase.cpp)
target_compile_definitions(odbcappendertestcase PRIVATE ${LOG4CXX_COMPILE_DEFINITIONS} ${APR_COMPILE_DEFINITIONS} ${APR_UTIL_COMPILE_DEFINITIONS} )
target_include_directories(odbcappendertestcase PRIVATE ${CMAKE_CURRENT_LIST_DIR} $<TARGET_PROPERTY:log4cxx,INCLUDE_DIRECTORIES>)
target_link_libraries(odbcappendertestcase log4cxx testingFramework testingUtilities ${APR_LIBRARIES} ${APR_SYSTEM_LIBS})

=== src/test/cpp/defaultinit/CMakeLists.txt ===
add_executable(defaultinittestcase testcase1.cpp testcase2.cpp testcase3.cpp testcase4.cpp)
set(ALL_LOG4CXX_TESTS ${ALL_LOG4CXX_TESTS} defaultinittestcase PARENT_SCOPE)

=== src/test/cpp/helpers/CMakeLists.txt ===
set(HELPER_TESTS 
    absolutetimedateformattestcase
    cacheddateformattestcase
    charsetdecodertestcase
    charsetencodertestcase
    cyclicbuffertestcase
    datetimedateformattestcase
    filewatchdogtest
    inetaddresstestcase
    iso8601dateformattestcase
    messagebuffertest
    optionconvertertestcase
    propertiestestcase
    relativetimedateformattestcase
    stringhelpertestcase
    stringtokenizertestcase
    syslogwritertest
    threadtestcase
    timezonetestcase
    transcodertestcase
)
foreach(fileName IN LISTS HELPER_TESTS)
    add_executable(${fileName} "${fileName}.cpp")
    target_compile_definitions(${fileName} PRIVATE ${APR_COMPILE_DEFINITIONS} ${APR_UTIL_COMPILE_DEFINITIONS} )
    target_include_directories(${fileName} PRIVATE ${CMAKE_CURRENT_LIST_DIR} $<TARGET_PROPERTY:log4cxx,INCLUDE_DIRECTORIES> ${APR_INCLUDE_DIR})
endforeach()
target_sources(cacheddateformattestcase PRIVATE localechanger.cpp)
target_sources(datetimedateformattestcase PRIVATE  localechanger.cpp)
set(ALL_LOG4CXX_TESTS ${ALL_LOG4CXX_TESTS} ${HELPER_TESTS} PARENT_SCOPE)

## log4cxx 0.10.0

=== debian/changelog ===
log4cxx (0.10.0-4ubuntu1) vivid; urgency=medium

  * Resynchronise with Debian.  Remaining changes:
    - debian/patches/170-fix-socket-thread-not-starting.patch: Patch from
      Peter Soertens to fix an issue with the socket reconnection thread not
      starting.
    - Pass dh_makeshlibs -V to have stronger version dependencies.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 27 Nov 2014 12:25:51 +0000

log4cxx (0.10.0-4) unstable; urgency=medium

  * Remove unneeded B-Ds on graphviz, gsfonts and zlib1g-dev
  * Fix override in the *-doc-package regarding doxygen's jquery.js

 -- Tobias Frost <tobi@debian.org>  Wed, 30 Jul 2014 22:18:30 +0200

log4cxx (0.10.0-3) unstable; urgency=medium

  * Remove d/TODO
  * Adding d/gbp.conf to repositor
  * Remove config.sub/guess explicitly in clean target to avoid FTBFS on arm64
    (Closes: #752035)
  * Clean also generated ltmain.sh

 -- Tobias Frost <tobi@coldtobi.de>  Thu, 19 Jun 2014 15:34:19 +0200

log4cxx (0.10.0-2) unstable; urgency=medium

  * New maintainer. (Closes: #740507)
  * complete debian/ overhaul
    - switch from dpatch to quilt
    - switch to d/compat 9
    - switch to short debhelper format (d/rules)
    - switch to dh_autoreconf
    - d/source/format 3.0 quilt (Closes: #664399)
    - rewrite d/copyright in dep5 format
    - drop B/D on dpatch (fixes also a lintian error)
    - enable multiarch support
    - work a on package description to make linitan happier
      (all packages had same long descriptions and short one started with "A")
    - Add VCS* information to d/control
    - update to S/V 3.9.5 (no changes necessary after redoing the packaging)
    - adding misc:depends to d/control
    - Remove B/D on c++-compiler (which is a virtual package and not needed)
    - Add signature verifcation for source:
       added pgp key from file KEYS to upstream/signing-key.asc
       added support in d/watchfile
  * New patch 130-LOG4CXX-385.patch to fix FTBFS
  * Fix "Random crashes on exit()", new patch 140-bugfix-LOGCXX-322.patch,
    taken from the BTS -- thanks to Stephan Sürken (Closes: #578649)
  * New patch 150-bugfix-LOGCXX-365.patch to fix testsuite failure
  * Set priority of the -doc and -dev package to extra
  * New patch 160_use_packaged_find_apur_m4.patch, to use the packaged m4
    macros to detect libapr
  * Add several lintian overrides, e.g for doxygen stuff, false-positive
    regarding the upstream signing key, no changelogs available.

 -- Tobias Frost <tobi@coldtobi.de>  Sat, 15 Mar 2014 21:22:26 +0100

log4cxx (0.10.0-1.3) unstable; urgency=low

  * Non-maintainer upload.
  * Use the autotools-dev dh addon to update config.guess/config.sub for new
    ports (closes: #548925, #726387).

 -- Colin Watson <cjwatson@debian.org>  Thu, 14 Nov 2013 13:55:37 +0000

log4cxx (0.10.0-1.2ubuntu3) saucy; urgency=low

  * Use the autotools-dev dh addon to update config.guess/config.sub for
    arm64.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 14 Oct 2013 23:27:48 +0100

log4cxx (0.10.0-1.2ubuntu2) precise; urgency=low

  * Pass dh_makeshlibs to have stronger version dependencies.
    (LP: #945112)
  * d/rules: Run unit tests on build. (LP: #945118). d/control: add
    ant, ant-contrib-cpptasks, and zip all used to run unit tests.
  * d/patches/91-bugfix-LOGCXX-365.dpatch: Fixes test suite to run post
    2010. Upstream bug LOGCXX-365, fixed in next release.

 -- Clint Byrum <clint@ubuntu.com>  Fri, 02 Mar 2012 14:54:05 -0800

log4cxx (0.10.0-1.2ubuntu1) oneiric; urgency=low

  * Merge from debian/unstable, new changes:
    - debian/patches/130-bugfix-LOGCXX-322.dpatch:
      patch from Stephan Sürke to fix a potential segfault on exit
      (Closes: #578649)
    - debian/patches/140-fix-socket-thread-not-starting.dpatch:
      patch from Peter Soertens to fix an issue with the socket
      reconnection thread not starting (LP: #785134)

 -- Andreas Moog <amoog@ubuntu.com>  Sun, 03 Jul 2011 10:22:17 +0000

log4cxx (0.10.0-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Don't ship .la files (Closes: #522197, #622538).

 -- Luk Claes <luk@debian.org>  Sun, 26 Jun 2011 15:11:52 +0200

log4cxx (0.10.0-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * debian/patches/120-gcc-4.4.dpatch added, fixes FTBFS with
    GCC 4.4, thanks to Martin Michlmayr (Closes: #510759)

 -- David Paleino <dapal@debian.org>  Mon, 21 Dec 2009 17:10:21 +0100

log4cxx (0.10.0-1) unstable; urgency=low

  * New maintainer (Closes: #491015)
  * New Upstream Release (Closes: #474138, #483191).

  * Upstream release no longer uses libxml2 (Closes: #475891, #416758)

  * debian/changelog: updated with new changes
  * debian/watch: added watch file for uscan upstream version monitoring
  * debian/control: added c++-compiler, libapr1-dev, and libaprutil1-dev to
    Build-Depends
  * debian/control: updated standards version to 3.0.0 (per lintian)
  * debian/control: updated package names to log4cxx10*
  * debian/control: added replaces and conflicts for -dev packages
    to allow upgrade from liblog4cxx9-dev
  * debian/control: added Homepage field to source package
  * debian/control: changed debhelper version to >=5
  * debian/control: set conflict for liblog4cxx10-dev to liblog4cxx9-dev
  * debian/control: added depends for liblog4cxx10-dev to libapr1-dev and
    libaprutil1-dev
  * debian/copyright: updated source location
  * debian/copyright: removed apache license and referenced
    /usr/share/common-licenses/Apache-2.0
  * debian/compat: changed to compatibility level 5 (recommended level) but
    could be set back to 4 if someone tests it
  * debian/docs: removed missing upstream files NEWS, README
  * debian/liblog4cxx9*: moved to liblog4cxx10*
  * debian/liblog4cxx10-doc.doc-base: changed name and install locations from
    liblog4cxx9-doc to liblog4cxx10-doc
  * debian/liblog4cxx10-doc.doc-base: changed section from Apps/Programming to
    Programming/C++ per lintian warning


=== debian/control ===
Source: log4cxx
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Tobias Frost <tobi@debian.org>
Homepage: http://logging.apache.org/log4cxx/index.html
Vcs-Git: git://gitorious.org/log4cxx-debian/log4cxx-debian.git
Vcs-Browser: https://gitorious.org/log4cxx-debian/log4cxx-debian
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               doxygen,
               libapr1-dev,
               libaprutil1-dev
Standards-Version: 3.9.5

Package: liblog4cxx10-dev
Section: libdevel
Priority: extra
Architecture: any
Depends: libapr1-dev,
         libaprutil1-dev,
         liblog4cxx10 (= ${binary:Version}),
         ${misc:Depends}
Conflicts: liblog4cxx9-dev
Replaces: liblog4cxx9-dev
Suggests: liblog4cxx10-doc (= ${source:Version}), pkg-config
Description: Logging library for C++ (development files)
 Log4cxx is the C++ port of log4j, a logging framework for JAVA.
 Log4cxx attempts to mimic log4j usage as much as the language will
 allow and to be compatible with log4j configuration and output formats.
 .
 This package provides the development files.

Package: liblog4cxx10
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Logging library for C++
 Log4cxx is the C++ port of log4j, a logging framework for JAVA.
 Log4cxx attempts to mimic log4j usage as much as the language will
 allow and to be compatible with log4j configuration and output formats.

Package: liblog4cxx10-doc
Section: doc
Priority: extra
Architecture: all
Depends: base-files (>=4.0.4), ${misc:Depends}
Description: Documentation for log4cxx
 Log4cxx is the C++ port of log4j, a logging framework for JAVA.
 Log4cxx attempts to mimic log4j usage as much as the language will
 allow and to be compatible with log4j configuration and output formats.
 .
 This package provides doxygen documentation for the library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules for the log4cxx logging library
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --parallel --with autoreconf

override_dh_autoreconf:
	dh_autoreconf ./autogen.sh

override_dh_auto_configure:
	dh_auto_configure -- --prefix=/usr

override_dh_auto_clean:
	! [ -f Makefile ] || make distclean


override_dh_auto_test:
	# Run test, but for now, ignore results.
	# In Debian the testsuite was never run before, so no loss. To avoid unwanted surprises
	# I'll better first ignore results.
	-dh_auto_test

override_dh_makeshlibs:
	dh_makeshlibs -V

=== debian/watch ===
# format version number, currently 3; this line is compulsory!
version=3

# this is the main Apache server as far as I can tell
# dists are in separate directories by version number
opts=pgpsigurlmangle=s/$/.asc/ http://www.apache.org/dist/logging/log4cxx/(?:[\d\.]+)/apache-log4cxx-([\d\.]+)\.tar\.gz

## log4cxx 0.11.0

=== debian/changelog ===
log4cxx (0.11.0-2+deb11u1) bullseye-security; urgency=medium

  * Non-maintainer upload by the LTS Security Team.
  * Security fixes for CVE-2025-54812 & CVE-2025-54813 from upstream:
    - d/p/CVE-2025-54812*: (Closes: #1111879)
      + Escape any logger name '&' or '"' in html attribute data (PR#509)
      + Escape any thread name '&' or '"' in html attribute data (PR#514)
    - d/p/CVE-2025-54813*: (Closes: #1111881)
      + Escape control characters in JSONLayout data (PR#512)

 -- Lukas Märdian <slyon@debian.org>  Sun, 28 Sep 2025 22:25:47 +0200

log4cxx (0.11.0-2) unstable; urgency=medium

  * Upload to unstable to start the transition.
    (Transition Bug #970402)

 -- Tobias Frost <tobi@debian.org>  Tue, 15 Sep 2020 22:39:03 +0200

log4cxx (0.11.0-1) experimental; urgency=medium

  * Upload to experimental due to soname bump.
  * New upstream release. (Closes: #513759)
    - Drop all patches except 160_use_packaged_find_apur_m4.patch, as
      upstream has applied them in the new version.
    - The m4 directory has been moved to src, so adapt said patch for new
      location. Also, d/clean updated to reflect this change.
    - The new upstream version requires a SONAME bump on the packages.
    - Remove obsolete overrides from source/lintian-overrides
    - Override some lintian false positives about missing code.
  * Updating upstream keyring.
  * Clean more files using d/clean
  * Temporarily disable a network-based test.
  * Fix liblog4cxx-doc.docs to find doxygen docs.
  * Remove override for dh_auto_test
  * Minify upstream keyring to fix public-upstream-key-not-minimal.
  * Hint dh_installdocs to install into the right package.
  * Enable CI on salsa.d.o
  * Update autopkgtest.

 -- Tobias Frost <tobi@debian.org>  Tue, 25 Aug 2020 00:13:04 +0200

log4cxx (0.10.0-16) sid; urgency=medium

  [ Ondřej Nový ]
  * d/tests: Use AUTOPKGTEST_ARTIFACTS instead of ADT_ARTIFACTS
  * d/tests: Use AUTOPKGTEST_TMP instead of ADTTMP

  [ Tobias Frost ]
  * Use debhelper-compat instead of d/compat; bump compat to level 13.
    - put the static library into debian/non-installed.
  * Bump S-V to 4.5.0, no changes.
  * Remove -Wl,--as-needed from d/rules, it is default now in the toolchain.

 -- Tobias Frost <tobi@debian.org>  Sun, 23 Aug 2020 19:46:18 +0200

log4cxx (0.10.0-15) sid; urgency=medium

  * Make the build reproducible, thanks lamby for the patch. (Closes: #901615)
  * Bump S-V to 4.2.1 -- no changes required

 -- Tobias Frost <tobi@debian.org>  Sun, 26 Aug 2018 16:43:21 +0200

log4cxx (0.10.0-14) sid; urgency=medium

  * Update copyright years.
  * Replace dependency for autopkgtests on liblog4cxx10-dev with unversioned
    one. Thanks to Paul Genvers for the report. (Closes: #905331)
  * Also drop unneeded dependency for autopkgtest on build-essential.
  * Bump S-V 4.2.0
    - Add "Rules-Require-Root: no" to d/control.

 -- Tobias Frost <tobi@debian.org>  Fri, 03 Aug 2018 18:07:05 +0800

log4cxx (0.10.0-13) sid; urgency=medium

  * Updated repository location after move to salsa.d.o.
  * Bump S-V to 4.1.3, needed change:
    - Remove Priority:extra from d/control, as this priority is obsolete.
  * Removing transitional packages.
  * Bump compat level to 11
    - Fix liblog4cxx-doc.doc-base, as docs are now under
      /usr/share/doc/log4cxx-dev/html.
  * Move source.lintian-overrides to source dir.
  * Remove Break/Conflicts on packages already removed in oldstable.
  * Cleanup obsolete lintian-overrides.
  * Install NOTICE also into the doc directories, as required by the
    license.
  * Install examples into the -dev package.
  * Update patch metadatas and add dep3-headers if not already there.
  * Remove versioned dependency on base-files for liblog4cxx-doc, as
    the version constraint is fullfilled long ago already.
  * Add grapviz to Build-Depends-Indep, to complete doxygen.

 -- Tobias Frost <tobi@debian.org>  Wed, 04 Apr 2018 23:25:10 +0200

log4cxx (0.10.0-12) sid; urgency=medium

  * Also fix the testsuite with GCC-6.
  * Add Multi-Arch:xxx hints to the doc and dev packages.
  * Change to compat level 10:
    - change d/compat
    - Update B-D on debhelper >10, and remove B-D on dh-autoreconf
      (will be pulled in by debhelper 10)
    - parallel and with-autoreconf switches are now default, remove them
      from d/rules
    - add some lintian override (wrong-positives) about config.(guess|sub)
  * Change Vcs-Git to secure https:// URI
  * New patch 190-spelling-errors.patch
  * Remove some unused lintian overrides
  * Enable harderning

 -- Tobias Frost <tobi@debian.org>  Sun, 23 Oct 2016 13:20:49 +0200

log4cxx (0.10.0-11) sid; urgency=medium

  * Fix FTBFS with GCC-6. (Closes: #811768)
  * Bump S-V to 3.9.8, no changes required.
  * Drop explicit versioned B-D on g++5 and libstdc++-5-dev.

 -- Tobias Frost <tobi@debian.org>  Fri, 01 Jul 2016 20:01:33 +0200

log4cxx (0.10.0-10) sid; urgency=medium

  * Make transitional packages Priority:extra (fixes lintian warning)
  * dep8 autpkgtest: Work around #809661 by redirecting sterr to stdout
  * d/control:
    - remove auto_clean override, it's not needed
    - at least when specifying the buildsystem (debhelper thinks it's ant)
    - override for auto_configure is then also no longer needed

 -- Tobias Frost <tobi@debian.org>  Sat, 02 Jan 2016 15:56:58 +0100

log4cxx (0.10.0-9) sid; urgency=medium

  * Upload to sid, transistion has started. (Closes: #791192)
  * Wrap extended description in d/control.

 -- Tobias Frost <tobi@debian.org>  Mon, 03 Aug 2015 21:27:07 +0200

log4cxx (0.10.0-8) experimental; urgency=medium

  * Upload to experimental
  * Rename doc and dev package to not include soname
  * Prepare library package for gcc5 and cxx11 ABI:
    - rename library package to 10v5
    - make sure to build against gcc5 from experimental
  * Cleanup d/rules

 -- Tobias Frost <tobi@debian.org>  Fri, 10 Jul 2015 07:47:19 +0200

log4cxx (0.10.0-7) unstable; urgency=medium



=== debian/control ===
Source: log4cxx
Section: devel
Priority: optional
Maintainer: Tobias Frost <tobi@debian.org>
Homepage: https://logging.apache.org/log4cxx/index.html
Vcs-Git: https://salsa.debian.org/debian/log4cxx.git
Vcs-Browser: https://salsa.debian.org/debian/log4cxx
Build-Depends: debhelper-compat (= 13),
               libapr1-dev,
               libaprutil1-dev,
               zip
Build-Depends-Indep: doxygen,
                     graphviz
Standards-Version: 4.5.0
Rules-Requires-Root: no

Package: liblog4cxx-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libapr1-dev,
         libaprutil1-dev,
         liblog4cxx11 (= ${binary:Version}),
         ${misc:Depends}
Suggests: liblog4cxx-doc (= ${source:Version}), pkg-config
Description: Logging library for C++ (development files)
 Log4cxx is the C++ port of log4j, a logging framework for JAVA.
 Log4cxx attempts to mimic log4j usage as much as the language will
 allow and to be compatible with log4j configuration and output formats.
 .
 This package provides the development files.

Package: liblog4cxx11
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: zip
Description: Logging library for C++
 Log4cxx is the C++ port of log4j, a logging framework for JAVA.
 Log4cxx attempts to mimic log4j usage as much as the language will
 allow and to be compatible with log4j configuration and output formats.

Package: liblog4cxx-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Documentation for log4cxx
 Log4cxx is the C++ port of log4j, a logging framework for JAVA.
 Log4cxx attempts to mimic log4j usage as much as the language will
 allow and to be compatible with log4j configuration and output formats.
 .
 This package provides doxygen documentation for the library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@ --buildsystem=autoconf

override_dh_autoreconf:
	dh_autoreconf ./autogen.sh

override_dh_installdocs:
	dh_installdocs --doc-main-package=liblog4cxx-doc -p liblog4cxx-doc
	dh_installdocs --remaining-packages

=== debian/watch ===
# format version number, currently 3; this line is compulsory!
version=3

# this is the main Apache server as far as I can tell
# dists are in separate directories by version number
opts=pgpsigurlmangle=s/$/.asc/ https://www.apache.org/dist/logging/log4cxx/(?:[\d\.]+)/apache-log4cxx-([\d\.]+)\.tar\.gz
